"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = __importDefault(require("crypto"));
const types_1 = require("../../types");
exports.generateSignature = (data, path, secret, nonce) => {
    const secretBuffer = new Buffer(secret, 'base64');
    const hash = crypto_1.default.createHash('sha256');
    const hmac = crypto_1.default.createHmac('sha512', secretBuffer);
    const hashDigest = hash.update(nonce + data).digest('binary');
    const hmacDigest = hmac
        .update(path + hashDigest, 'binary')
        .digest('base64');
    return hmacDigest;
};
exports.getHttpPrefix = (network) => {
    switch (network) {
        case types_1.Network.MAINNET:
            return 'https://api.kraken.com';
        default:
            throw new Error('Kraken only supports the MAINNET network.');
    }
};
